// todo: make sure the W_OK buf[0] value is updated to match how many bytes were written

#define ethuploadrev          1.02


#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "F:\SOFTWARE\Dev\ETH\Common Firmware\W7100.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\serial.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\types.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\TCPIPcore.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\socket.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\delay.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\codeflash.h"
#include "task_config.h"
#include "iap.h"
#include "ETH-IIRO-16.h"

uint8 Asynch_Reset;

bit        UPLOAD_MODE;
uint8      UPLOAD_STATUS;

uint8      currentIDO[numdobytes] = {0xFF, 0xFF};

void WriteIDO(uint8 byteIndex, uint8 dat)
{
    P0 = dat;
    if ( byteIndex == 0 ) 
    {
        P2_0 = 1; 
        P2_0 = 0; 
        P2_1 = 0;
    } 
    else 
    { 
        P2_3 = 1; 
        P2_3 = 0; 
        P2_2 = 0;
    }
}


void  ETH_IIRO_16_Go(SOCKET s, uint16 port, uint8 xdata * data_buf)
{
    uint16       len, i;
    t_dgram      *pdgram = data_buf;

    switch (getSn_SR(s))
    {
        case SOCK_ESTABLISHED:                                                          /* if connection is established */
            if(getSn_IR(s) & Sn_IR_CON)                                                 // check Sn_IR_CON bit
            {

              // send one zero-length ACK packet to all sockets that have been connected, except *this* one, each time a new connection is made
              // added March 2017
              SOCKET soc;
              for ( soc=0; soc<6; soc++)
              {
                if ( soc == s ) continue;
                if ( getSn_SR(soc) != SOCK_ESTABLISHED ) continue;
                len = 0; //set length is 1460 Byte
                send(soc, (uint8 *)data_buf, len);
              }

#ifdef DEBUG_PRINT
                    printf("Connected.\r\n");
#endif
                setSn_IR(s,Sn_IR_CON);                                                  // clear Sn_IR_CON
            }
            if (( len = getSn_RX_RSR(s)) > 0)                                           /* check Rx data */
            {
                len = recv(s, data_buf, len);                                           /* read the received data */
#ifdef DEBUG_PRINT
                    printf("CH %bu: Received %u bytes\r\n", s,           len);
                    printf("%bu:[%c%c%c%c]\r\n",            data_buf[0], data_buf[1], data_buf[2], data_buf[3], data_buf[4]);
#endif

                switch( ( *pdgram ).type)
                {
                    case AIO_ETH_CMD_WDBG:
                        P2 = data_buf[6];

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = P2;

                        len       = send(s, data_buf, 6);                        
                    
                    
                        break;
                    case AIO_ETH_CMD_RAWL: // NOT FOR THIS DEVICE
                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK__Err;
                        ( *pdgram ).buf[0] = 50; // ERROR_NotYetImplemented called ERROR_NOTSUPPORTED

                        len       = send(s, data_buf, 6);                       
                        break;
                    
                    case AIO_ETH_CMD_RADI:
                        fActivity          = 1;
                        ( *pdgram ).len    = 9;
                        ( *pdgram ).type   = AIO_ETH_ACK_R_OK;
                        ( *pdgram ).buf[0] = 0x04;
                        ( *pdgram ).buf[1] = currentIDO[IDO07];
                        ( *pdgram ).buf[2] = currentIDO[IDO8F];
                        ( *pdgram ).buf[3] = IDI07;
                        ( *pdgram ).buf[4] = IDI8F;
                        len = send(s, data_buf, 10);
                        break;
                    
                    case AIO_ETH_CMD_DIO_:
                        fActivity          = 1;
                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK__Err;
                        ( *pdgram ).buf[0] = 50; // ERROR_NotYetImplemented called ERROR_NOTSUPPORTED
                        len       = send(s, data_buf, 6);
                        break;

                    case AIO_ETH_CMD_WADO:
                        fActivity = 1;
                        currentIDO[IDO07] = data_buf[6];
                        currentIDO[IDO8F] = data_buf[7];
                    
                        WriteIDO(IDO07, currentIDO[IDO07]);
                        WriteIDO(IDO8F, currentIDO[IDO8F]);

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = numdobytes;

                        len       = send(s, data_buf, 6);
                        break;

                    case AIO_ETH_CMD_WPDO:
                    {
                        
                        /*
                          takes an array of data with the following structure:
                            struct {
                              byte DataMask[(( *pdgram ).len/2)];
                              byte Data[(( *pdgram ).len/2)];
                            }
                        */
                        unsigned char L = ( *pdgram ).buf[0] / 2;
                        fActivity = 1;
                        for (i = 0; i < numdobytes; i++)
                        {
                            uint8 tmp = data_buf[6 + L + i]; // data to write
                            uint8 msk = data_buf[6 + i];// bit mask, 1 == bit that should get written
                            tmp = tmp & msk;
                            msk = ~msk;
                            ( *pdgram ).buf[i + L + 1] = currentIDO[i];
                            
                            tmp = (( *pdgram ).buf[i + L + 1] & msk) | tmp;
                            WriteIDO( i, currentIDO[i] = tmp );
                        }

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = 6;
                            len       = send(s, data_buf, 6);
                        break;
                    }

                    case AIO_ETH_CMD_WRPD:
                    {
                        
                        /*
                          takes an array of data with the following structure:
                            struct {
                              byte DataMask[numdobytes];
                              byte Data[numdobytes];
                            }
                          returns a struct of data with the following structure:
                            struct {
                              byte Data[numdobytes]; // DI values after write has occurred
                              byte PriorData[numdobytes]; // DI values before write occurred
                            }
                        */
                        unsigned char L = ( *pdgram ).buf[0] / 2;
                        fActivity = 1;
                        for (i = 0; i < numdobytes; i++)
                        {
                            uint8 tmp = data_buf[6 + L + i]; // data to write
                            uint8 msk = data_buf[6 + i];// bit mask, 1 == bit that should get written
                            tmp = tmp & msk;
                            msk = ~msk;
                            ( *pdgram ).buf[i + L + 1] = currentIDO[i];
                            tmp = (( *pdgram ).buf[i + L + 1] & msk) | tmp;
                            WriteIDO( i, tmp );
                            ( *pdgram ).buf[i + 1] = currentIDO[i] = tmp;
                        }


                        if (( *pdgram ).type == AIO_ETH_CMD_WPDO)
                        {
                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = numdobytes;
                            len       = send(s, data_buf, 6);
                        }else{ // AIO_ETH_CMD_WRPD
                        ( *pdgram ).len    = 9;
                        ( *pdgram ).type   = AIO_ETH_ACK_R_OK;
                        ( *pdgram ).buf[0] = numdobytes * 2;
                            len       = send(s, data_buf, 10);
                        }
                        break;
                    }

                    case AIO_ETH_CMD_ChIO:
                        fActivity = 1;

                        WriteIDO(IDO07, currentIDO[IDO07] = data_buf[6]);
                        WriteIDO(IDO8F, currentIDO[IDO8F] = data_buf[7]);

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = 2;

                        len       = send(s, data_buf, 6);
                        break;

                    case AIO_ETH_CMD_ChIP:
                        fActivity          = 1;
                        NetworkParam.ip[0] = ( *pdgram ).buf[0];
                        NetworkParam.ip[1] = ( *pdgram ).buf[1];
                        NetworkParam.ip[2] = ( *pdgram ).buf[2];
                        NetworkParam.ip[3] = ( *pdgram ).buf[3];

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = 4;

                        len                = send(s, data_buf, 6);
                        setSIPR( NetworkParam.ip );
                        user_flash_write((uint8*)&NetworkParam);

                        break;

                    case AIO_ETH_CMD_ChGW:
                        fActivity          = 1;
                        NetworkParam.gw[0] = ( *pdgram ).buf[0];
                        NetworkParam.gw[1] = ( *pdgram ).buf[1];
                        NetworkParam.gw[2] = ( *pdgram ).buf[2];
                        NetworkParam.gw[3] = ( *pdgram ).buf[3];

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = 4;

                        len = send(s, data_buf, 6);
                        setGAR( NetworkParam.gw );
                        user_flash_write((uint8*)&NetworkParam);
                        break;

                    case AIO_ETH_CMD_ChSM:
                        fActivity              = 1;
                        NetworkParam.subnet[0] = ( *pdgram ).buf[0];
                        NetworkParam.subnet[1] = ( *pdgram ).buf[1];
                        NetworkParam.subnet[2] = ( *pdgram ).buf[2];
                        NetworkParam.subnet[3] = ( *pdgram ).buf[3];

                        ( *pdgram ).len        = 5;
                        ( *pdgram ).type       = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0]     = 4;

                        len = send(s, data_buf, 6);
                        setSUBR( NetworkParam.subnet );
                        user_flash_write((uint8*)&NetworkParam);
                        break;

                    case AIO_ETH_CMD_ChNW:
                    case AIO_ETH_CMD_ChNP:
                        fActivity              = 1;
                        NetworkParam.ip[0]     = ( *pdgram ).buf[0];
                        NetworkParam.ip[1]     = ( *pdgram ).buf[1];
                        NetworkParam.ip[2]     = ( *pdgram ).buf[2];
                        NetworkParam.ip[3]     = ( *pdgram ).buf[3];

                        NetworkParam.subnet[0] = ( *pdgram ).buf[4];
                        NetworkParam.subnet[1] = ( *pdgram ).buf[5];
                        NetworkParam.subnet[2] = ( *pdgram ).buf[6];
                        NetworkParam.subnet[3] = ( *pdgram ).buf[7];

                        NetworkParam.gw[0]     = ( *pdgram ).buf[8];
                        NetworkParam.gw[1]     = ( *pdgram ).buf[9];
                        NetworkParam.gw[2]     = ( *pdgram ).buf[10];
                        NetworkParam.gw[3]     = ( *pdgram ).buf[11];

                        ( *pdgram ).len        = 5;
                        ( *pdgram ).type       = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0]     = 4;

                        len = send(s, data_buf, 6);

                        if (( *pdgram ).type == AIO_ETH_CMD_ChNW)
                        {
                            setSIPR( NetworkParam.ip );
                            setSUBR( NetworkParam.subnet );
                            setGAR( NetworkParam.gw );
                        }else{
                            Asynch_Reset = 100;
                        } user_flash_write((uint8*)&NetworkParam);
                        break;

                    case AIO_ETH_CMD_ChMC:
                        fActivity          = 1;
                        NetworkParam.mac[0] = ( *pdgram ).buf[0];
                        NetworkParam.mac[1] = ( *pdgram ).buf[1];
                        NetworkParam.mac[2] = ( *pdgram ).buf[2];
                        NetworkParam.mac[3] = ( *pdgram ).buf[3];
                        NetworkParam.mac[4] = ( *pdgram ).buf[4];
                        NetworkParam.mac[5] = ( *pdgram ).buf[5];

                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = 4;

                        len                = send(s, data_buf, 6);
                        setSHAR( NetworkParam.mac );
                        user_flash_write((uint8*)&NetworkParam);
                                                break;
                    
                    /////////////////////////////////////////
                    // version 1.26 changes RSta to have an optional 1-byte payload, "revision to return".  If passed "0" it returns the 1.25 packet; if passed "1" it returns the correct payload, with length etc.
                    // 1.25 doesn't stuff its W_OK Payload-Length byte, and puts OP[0] where the length should have been
                    /////////////////////////////////////////
                    
                    case AIO_ETH_CMD_RSta:
                    {
                        unsigned int rstaRev = 0;
                        fActivity          = 1;
                        if ((*pdgram).len >= 6) rstaRev = ((*pdgram).buf[1]==0) ? 0:1; // .buf[0] is payload length, assume "1"
                    
                    
                        ( *pdgram ).len    = 4 + sizeof( NetworkParam ) + rstaRev; // old rev put "4" instead of "5", new revs put "5" correctly
                        ( *pdgram ).type   = AIO_ETH_ACK_R_OK;
                        for (i = 0; i < sizeof( NetworkParam ); i++)
                            ( *pdgram ).buf[i+rstaRev] = *((uint8 *)( &NetworkParam ) + i ); // old rev put NetworkParam[0] where payload len belonged
                        if (rstaRev > 0)                       // old rev didn't stuff payload length
                            ( *pdgram ).buf[0] = sizeof( NetworkParam );
                        len                = send(s, data_buf, ( *pdgram ).len+1);
                        break;
                    }
                    case AIO_ETH_CMD_UDat:
                        fActivity          = 1;
                        break;
                    case AIO_ETH_CMD_UFin:
                        fActivity          = 1;

                        // if no errors
                        ( *pdgram ).len    = 5;
                        ( *pdgram ).type   = AIO_ETH_ACK_W_OK;
                        ( *pdgram ).buf[0] = 0;
                        len                = send(s, data_buf, 6);
                        //else send AIO_ETH_ACK__Err with status code
                        break;

                    case AIO_ETH_CMD_RPDI:
                    default:
                        fActivity        = 1;
                        ( *pdgram ).len  = 4;
                        ( *pdgram ).type = AIO_ETH_ACK__Err;
                        len              = send(s, data_buf, 5);

                        dprintf("total Length: %bu\r\n",   data_buf[0]);
                        dprintf("CMD: %08lx\r\n",          pdgram->type);
                        dprintf("payload length: %bu\r\n", data_buf[5]);
                        dprintf("buf[6]: %bx\r\n",         data_buf[6]);
                        break;
                } /* switch */

                dprintf("CH %bu: Send %u bytes to Client \r\n", s, len);

            } /* switch */
            break;
        case SOCK_CLOSE_WAIT:                                                           /* If the client request to close */
            disconnect(s);
            break;

        case SOCK_CLOSED:                                                               /* if a socket is closed */
            close(s);
            socket(s, ( Sn_MR_TCP ), port, Sn_MR_ND);
            break;

        case SOCK_INIT:                                                                 /* if a socket is initiated */
            listen(s);
            break;
    } /* switch */
} /* switch */
