#include <stdio.h>
#include <ctype.h>
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\serial.h"         // serial related functions
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "F:\SOFTWARE\Dev\ETH\Common Firmware\W7100.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\serial.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\types.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\TCPIPcore.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\socket.h"
#include "task_config.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\delay.h"
#include "ETH-IIRO-16.h"
#include "F:\SOFTWARE\Dev\ETH\Common Firmware\codeflash.h"
#include "update.h"

uint16      linecount_calculated;
uint16      expectedlinecount;
uint8       linelength;
uint8       linedata[16];                                                               // bytes of data as read from one line of the intel.hex file
uint16      lineaddr;                                                                   // start address of data from intel.hex line
uint8       linecsum;                                                                   // checksum read from line of intel.hex file
uint8       linecsum_calculated;                                                        // checksum built as data is parsed; checked against linecsum for verification
uint16      filecsum_calculated;                                                        // checksum built over entire file, sent to host to verify reception
uint16      filecsum;
uint16      maxusedaddr;
uint16      minusedaddr;

void   code_flash_test(unsigned int base_addr);


uint8  ReadByte( char *tok )                                                            // starting the process for interpreting intel.hex format
{
    uint8      n = 0;
    char       *c;

    c = tok;
    filecsum_calculated += *c;
    if (isxdigit(*c))
        if (*c < 'A')
            n = *c - '0';
        else
            n = *c - 'A' + 10;
    c++;
    filecsum_calculated += *c;
    n <<= 4;
    if (isxdigit(*c))
        if (*c < 'A')
            n += *c - '0';
        else
            n += *c - 'A' + 10;
    linecsum_calculated += n;
    return n;
} /* ReadByte */


uint16  ReadWord( char *tok )
{
    return ( ReadByte(tok) << 8 ) + ReadByte(tok + 2);
}


void  ETH_Firmware_Update_Go(SOCKET s, uint16 port, uint8 xdata * data_buf)
{
    static uint8      odlen        = 0, dlen = 0;
    static uint8      UPLOAD_MODE  = 0;
    uint16            len, i;
    t_dgram           *pdgram      = data_buf;
    t_UDat_dgram      *pdatgram    = data_buf;
    uint8             fulldatagram = 0;


    switch (getSn_SR(s))
    {
        case SOCK_ESTABLISHED:                                                          /* if connection is established */
            if(getSn_IR(s) & Sn_IR_CON)                                                 // check Sn_IR_CON bit
            {
                setSn_IR(s,Sn_IR_CON);                                                  // clear Sn_IR_CON
                odlen = 0;
                                    printf("\r\nACCES ETH-DIO-48 Upload Port Connected\r\n");
            }

            if (( len = getSn_RX_RSR(s)) > 0)                                           /* check Rx data */
                switch (odlen)
                {
                    case 0:
                        len   = recv(s, data_buf, 1);                                   /* read the received data */
                        dlen  = data_buf[0];
                        odlen = 1;
                        break;
                    default:
                        if (len <= dlen)
                            len = recv(s, data_buf + odlen, len);
                        else
                            len = recv(s, data_buf + odlen, dlen);
                        odlen += len;
                        dlen  -= len;
                        if (dlen == 0)
                        {
                            fulldatagram = odlen;
                            odlen        = 0;
#if 0
                                data_buf[fulldatagram] = '\0';
                                    printf("Upload Datagram Complete: %s\r\n", &( data_buf[5] ));
#endif
                        }
                        break;
                }                                                                       /* switch */

            if (fulldatagram)
                switch ( ( *pdgram ).type)
                {
                    case AIO_ETH_CMD_Upld:
                        fActivity            = 1;
                        dlen                 = 0;
                        UPLOAD_MODE          = 0;
                        UPLOAD_STATUS        = 0;
                        linecsum_calculated  = 0;
                        filecsum_calculated  = 0;
                        expectedlinecount    = 0;
                        linecount_calculated = 0;
                        maxusedaddr          = 0;
                        minusedaddr          = 0xFFFF;

                        UPLOAD_MODE          = 0x01;
                        UPLOAD_STATUS        = 0x01;                                    // upload incomplete status
                        expectedlinecount    = ( *pdgram ).buf[0] + (( *pdgram ).buf[1] << 8 );
                        if (( *pdgram ).buf[2] + (( *pdgram ).buf[3] << 8 ) != 0)
                            UPLOAD_STATUS = 0x20;                                       // invalid number of lines detected

#ifdef DEBUG_PRINT
                                    printf("Datagram Upld detected, Status = %02bX\r\n",                             UPLOAD_STATUS);
                                    printf("linecount: %u\r\nustat=%02bx\r\n%02bx%02bx%02bx%02bx\r\n%02bx%02bx\r\n", expectedlinecount, UPLOAD_STATUS, ( *pdgram ).buf[0],( *pdgram ).buf[1],( *pdgram ).buf[2],( *pdgram ).buf[3],( *pdgram ).buf[4],( *pdgram ).buf[5]);
#endif
                        filecsum  = ( *pdgram ).buf[4] + (( *pdgram ).buf[5] << 8 );

                        break;
                    case AIO_ETH_CMD_UDat:
                        fActivity = 1;
                        if (UPLOAD_MODE == 0x01)
                        {
                            if (UPLOAD_STATUS == 0x01)
                            {
                                if (( *pdatgram ).charcolon != ':') {UPLOAD_STATUS |= 0x02; return; } // bad data received in byte 0
                                filecsum_calculated += ':';

                                if (( *pdatgram ).linetype != 0x3030) {UPLOAD_STATUS |= 0x04; return; } // record type not 0x01
                                filecsum_calculated += 0x30;
                                filecsum_calculated += 0x30;

                                linelength           = ReadByte((uint8*)&(( *pdatgram ).linelength ));
                                lineaddr             = ReadWord((uint8*)&(( *pdatgram ).lineaddr ));
                                if (lineaddr + linelength - 1 > maxusedaddr) maxusedaddr = lineaddr + linelength - 1;
                                if (lineaddr < minusedaddr) minusedaddr = lineaddr;

                                if (( linelength * 2 ) != ( fulldatagram - 16 ))
                                {
                                    UPLOAD_STATUS         |= 0x08;
                                    data_buf[fulldatagram] = '\0';
                                    printf("Upload Datagram: %s\r\n",                                     &( data_buf[5] ));
                                    printf("Status=8, linelength=%02bx fulldatagram=%02bx compare=%02bx", linelength * 2, fulldatagram, fulldatagram - 16);
                                    return;
                                }  // unexpected length issue

                                for ( i = 0; i < linelength; i++ )
                                    linedata[i] = ReadByte( &(( *pdatgram ).buf[i * 2] ) );

                                linecsum = ReadByte( &(( *pdatgram ).buf[linelength * 2] ));
                                if ( linecsum_calculated )
                                {
                                    UPLOAD_STATUS         |= 0x10;
                                    data_buf[fulldatagram] = '\0';
                                    printf("Upload Datagram: %s\r\n",                                   &( data_buf[5] ));
                                    printf("Status=10, linecsum=%02bx csum_calc=%02bx, sum=%02bx \r\n", linecsum, linecsum_calculated, linecsum + linecsum_calculated);
                                    return;
                                } //checksum mismatch issue
                                linecount_calculated++;

                                // confirm file checksum

                                // if all done, and no errors, clear upload status bit 0
                                if (linecount_calculated == expectedlinecount)
                                {
                                    UPLOAD_STATUS &= ~0x01; // no longer pending
                                    if (filecsum + filecsum_calculated != 0x0000)
                                    {
                                        UPLOAD_STATUS |= 0x40; // file checksum mismatch
                                        return;
                                    }
                                }

                                for (i = 0; i < linelength; i++)
                                    XBYTE[x_data_firmware_storage_start + lineaddr + i] = linedata[i];
                            } else {UPLOAD_STATUS |= 0x80; return; } // unexpectedly got UDat (extra lines?)
                        } else {                                                          // UDat called but not expecting UDat (Upld not called first)
                        }
                        break;

                    case AIO_ETH_CMD_UFin:                                              // payload includes 16-bit "address to start from" but is currently ignored (device resets)
                        fActivity = 1;
#ifdef DEBUG_PRINT
                        printf("Datagram UFin detected, Status = %02bX\r\n",                                  UPLOAD_STATUS);
                        printf("DEBUG DATA\n\rlinedata is @ %p\n\rHIGHEST BYTE @ %04x\r\nLOW BYTE @ %04x\r\n",linedata, maxusedaddr, minusedaddr);
#endif
                        UPLOAD_MODE = 0;
                        if (UPLOAD_STATUS == 0)
                        {
                            ( *pdgram ).len  = 4;
                            ( *pdgram ).type = AIO_ETH_ACK_W_OK;
                            len              = send(s, data_buf, 5);

                            // perform copy from RAM to FLASH
                            EA = 0;
                            printf("launching flash copy operation from %04x\r\n", LOCATION_OF_FLASH_WRITING_ROUTINE);
                            (( void (code*)(void)) LOCATION_OF_FLASH_WRITING_ROUTINE )();
                            printf("\r\nflash copy returned?!?!!? unexpected should have crashed....\r\n");
                        }else{
                            ( *pdgram ).len    = 5;
                            ( *pdgram ).type   = AIO_ETH_ACK__Err;
                            ( *pdgram ).buf[0] = UPLOAD_STATUS;
                            len = send(s, data_buf, 6);
                        }
                        odlen = 0;
                        if (( len = getSn_RX_RSR(s)) > 0)                               /* drain the remain data */
                            len = recv(s, data_buf, len);
                        break;
                }                                                                       // end switch(type)
            fulldatagram = 0;
            break;
        case SOCK_CLOSE_WAIT:                                                           /* If the client request to close */
            if (( len = getSn_RX_RSR(s)) > 0)                                           /* check the remain data */
                len = recv(s, data_buf, len);
            disconnect(s);
            break;

        case SOCK_CLOSED:                                                               /* if a socket is closed */
            close(s);
            socket(s, ( Sn_MR_TCP ), port, Sn_MR_ND);
            //socket(s, (Sn_MR_TCP),port,0x00);
            break;

        case SOCK_INIT:                                                                 /* if a socket is initiated */
            listen(s);
            break;
    } /* switch */
} /* ETH_Firmware_Update_Go */




